Attribute VB_Name = "PrinterIPC"
Option Explicit

Public Enum Object_States
    STATUS_WAIT_0 = &H0
    STATUS_ABANDONED_WAIT_0 = &H80
    STATUS_USER_APC = &HC0
    STATUS_TIMEOUT = &H102
    STATUS_PENDING = &H103
    STATUS_SEGMENT_NOTIFICATION = &H40000005
    STATUS_GUARD_PAGE_VIOLATION = &H80000001
    STATUS_DATATYPE_MISALIGNMENT = &H80000002
    STATUS_BREAKPOINT = &H80000003
    STATUS_SINGLE_STEP = &H80000004
    STATUS_ACCESS_VIOLATION = &HC0000005
    STATUS_IN_PAGE_ERROR = &HC0000006
    STATUS_INVALID_HANDLE = &HC0000008
    STATUS_NO_MEMORY = &HC0000017
    STATUS_ILLEGAL_INSTRUCTION = &HC000001D
    STATUS_NONCONTINUABLE_EXCEPTION = &HC0000025
    STATUS_INVALID_DISPOSITION = &HC0000026
    STATUS_ARRAY_BOUNDS_EXCEEDED = &HC000008C
    STATUS_FLOAT_DENORMAL_OPERAND = &HC000008D
    STATUS_FLOAT_DIVIDE_BY_ZERO = &HC000008E
    STATUS_FLOAT_INEXACT_RESULT = &HC000008F
    STATUS_FLOAT_INVALID_OPERATION = &HC0000090
    STATUS_FLOAT_OVERFLOW = &HC0000091
    STATUS_FLOAT_STACK_CHECK = &HC0000092
    STATUS_FLOAT_UNDERFLOW = &HC0000093
    STATUS_INTEGER_DIVIDE_BY_ZERO = &HC0000094
    STATUS_INTEGER_OVERFLOW = &HC0000095
    STATUS_PRIVILEGED_INSTRUCTION = &HC0000096
    STATUS_STACK_OVERFLOW = &HC00000FD
    STATUS_CONTROL_C_EXIT = &HC000013A
 End Enum
 
 '\ Used to watch the printer...
Public Type PRINTER_NOTIFY_INFO_DATA
    Type As Integer
    Field As Integer
    Reserved As Long
    id As Long
    cdBuffer As Long
    pBuffer As Long
End Type

Public Type PRINTER_NOTIFY_OPTIONS_TYPE
    Type As Integer
    Reserved_0 As Integer
    Reserved_1 As Long
    Reserved_2 As Long
    Count As Long
    pFields As PRINTER_NOTIFY_INFO_DATA
End Type

Public Type PRINTER_NOTIFY_OPTIONS
    Version As Long 'should be set to 2
    Flags As Long
    Count As Long
    FirstElement As PRINTER_NOTIFY_OPTIONS_TYPE
End Type

Public Declare Function FindFirstPrinterChangeNotification Lib "winspool.drv" (ByVal hPrinter As Long, ByVal fdwFlags As Long, ByVal fdwOptions As Long, lpPrinterNotifyOptions As PRINTER_NOTIFY_OPTIONS) As Long
Public Declare Function FindNextPrinterChangeNotification Lib "winspool.drv" (ByVal hChange As Long, pdwChange As Long, pvReserved As Long, ppPrinterNotifyInfo As Long) As Long
Public Declare Function FindClosePrinterChangeNotification Lib "winspool.drv" (ByVal hChange As Long) As Long
'Private Declare Function RegisterWaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Public Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Public Const INFINITE = &HFFFF      '  Infinite timeout
Public Const WAIT_REASONABLE = 1000 'Default timeout
Public WAIT_TIMEOUT As Long

Private mChangeNotificationHandle As Long

'\\ Private messages used to communicate between the printerwatch OCX instances and
'\\ the PRINTWATCH self contained executable.
Public Const MSG_STARTWATCH = "MCL_PRINT_ADDWATCH" 'wParam is the printer handle, lParam is the return window handle
Public Const MSG_STOPWATCH = "MCL_PRINT_STOPWATCH" 'wParam is the printer handle, lParam is the return window handle
Public Const MSG_CHANGENOTIFY = "MCL_PRINT_NOTIFY"

Public Declare Function RegisterWindowMessage Lib "user32" Alias "RegisterWindowMessageA" (ByVal lpString As String) As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessageString Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long

Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long

Public hOldProc As Long
Public hWnd_Communicator As Long

Public Const GWL_WNDPROC = (-4)
Public Declare Function SetWindowLongApi Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Public Declare Function IsWindow Lib "user32" (ByVal hwnd As Long) As Long

Public Const WINDOWTITLE_CLIENT = "Merrion Computing IPC - Client"
Public Const WINDOWTITLE_SERVER = "Merrion Computing IPC - Server"

Public Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long

Private Declare Function RegisterHotKey Lib "user32" (ByVal hwnd As Long, ByVal id As Long, ByVal fsModifiers As Long, ByVal vk As Long) As Long
Public Const WM_HOTKEY = &H312
Public Const MOD_WIN = &H8

Public Enum PrinterChangeNotifications
     PRINTER_CHANGE_ADD_PRINTER = &H1
     PRINTER_CHANGE_SET_PRINTER = &H2
     PRINTER_CHANGE_DELETE_PRINTER = &H4
     PRINTER_CHANGE_FAILED_CONNECTION_PRINTER = &H8
     PRINTER_CHANGE_PRINTER = &HFF
     PRINTER_CHANGE_ADD_JOB = &H100
     PRINTER_CHANGE_SET_JOB = &H200
     PRINTER_CHANGE_DELETE_JOB = &H400
     PRINTER_CHANGE_WRITE_JOB = &H800
     PRINTER_CHANGE_JOB = &HFF00
     PRINTER_CHANGE_ADD_FORM = &H10000
     PRINTER_CHANGE_SET_FORM = &H20000
     PRINTER_CHANGE_DELETE_FORM = &H40000
     PRINTER_CHANGE_FORM = &H70000
     PRINTER_CHANGE_ADD_PORT = &H100000
     PRINTER_CHANGE_CONFIGURE_PORT = &H200000
     PRINTER_CHANGE_DELETE_PORT = &H400000
     PRINTER_CHANGE_PORT = &H700000
     PRINTER_CHANGE_ADD_PRINT_PROCESSOR = &H1000000
     PRINTER_CHANGE_DELETE_PRINT_PROCESSOR = &H4000000
     PRINTER_CHANGE_PRINT_PROCESSOR = &H7000000
     PRINTER_CHANGE_ADD_PRINTER_DRIVER = &H10000000
     PRINTER_CHANGE_SET_PRINTER_DRIVER = &H20000000
     PRINTER_CHANGE_DELETE_PRINTER_DRIVER = &H40000000
     PRINTER_CHANGE_PRINTER_DRIVER = &H70000000
     PRINTER_CHANGE_TIMEOUT = &H80000000
     PRINTER_CHANGE_ALL = &H7777FFFF
End Enum

'\\ API Error decoding
Declare Function FormatMessage Lib "kernel32" Alias "FormatMessageA" (ByVal dwFlags As Long, lpSource As Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, ByVal lpBuffer As String, ByVal nSize As Long, Arguments As Long) As Long

Public Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000

'\ Declarations for StringFromPointer
Private Declare Function IsBadStringPtrByLong Lib "kernel32" Alias "IsBadStringPtrA" (ByVal lpsz As Long, ByVal ucchMax As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
                       (Destination As Any, _
                       Source As Any, _
                       ByVal Length As Long)


Public Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Public Function CreateCommunicationWindow(ByVal client As Boolean) As Long

Dim hwndThis As Long
Dim sWindowTitle As String

If client Then
    sWindowTitle = WINDOWTITLE_CLIENT
Else
    sWindowTitle = WINDOWTITLE_SERVER
End If

hwndThis = CreateWindowEx(0, "STATIC", sWindowTitle, 0, 0, 0, 0, 0, 0, 0, App.hInstance, ByVal 0&)
If IsWindow(hwndThis) Then
    '\\ Subclass this window
    hOldProc = SetWindowLongApi(hwndThis, GWL_WNDPROC, AddressOf VB_WindowProc)
End If
CreateCommunicationWindow = hwndThis

End Function

Public Sub InitialiseInterProcessCommunication(ByVal client As Boolean)

Dim sWindowTitle As String

'\\ Register the messages used to communicate between the processes
If WM_MCL_STARTWATCH = 0 Then
    MsgBox "Could not register STARTWATCH message ", vbCritical, "MCL Printer Watch"
ElseIf WM_MCL_STOPWATCH = 0 Then
    MsgBox "Could not register STOPWATCH message", vbCritical, "MCL Printer Watch"
ElseIf WM_MCL_CHANGENOTIFY = 0 Then
    MsgBox "Could not register CHANGENOTIFY message", vbCritical, "MCL Change Notify"
End If

'\\ Create the server communication window....
If Not client Then
    hWnd_Communicator = CreateCommunicationWindow(client)
    Call RegisterHotKey(hWnd_Communicator, 1, MOD_WIN, vbKeyP)
End If


End Sub


Public Sub TerminateInterProcessCommunication(ByVal hwnd As Long)

If IsWindow(hwnd) Then
    Call SetWindowLongApi(hwnd, GWL_WNDPROC, hOldProc)
    Call DestroyWindow(hwnd)
End If

End Sub


'\\ --[VB_WindowProc]-------------------------------------------------------------------
'\\ 'typedef LRESULT (CALLBACK* WNDPROC)(HWND, UINT, WPARAM, LPARAM);
'\\ Parameters:
'\\   hwnd - window handle receiving message
'\\   wMsg - The window message (WM_..etc.)
'\\   wParam - First message parameter
'\\   lParam - Second message parameter
'\\ Note:
'\\    When subclassing a window proc using this, set the eventhandler's
'\\    hOldWndProc property to the window's previous window proc address.
'\\ ----------------------------------------------------------------------------------------
'\\  (c) 2001 - Merrion Computing Ltd
'\\  http://www.merrioncomputing.com
'\\ ----------------------------------------------------------------------------------------
Public Function VB_WindowProc(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Dim sPrintername As String

If wMsg = WM_MCL_STARTWATCH Then
    'wParam is the return window handle,
    'lParam is the printer name
    sPrintername = GetGlobalString(lParam)
    Call AddWatch(wParam, sPrintername)
    
ElseIf wMsg = WM_MCL_STOPWATCH Then
    'wParam is the return window handle,
    'lParam is the printer name
    sPrintername = GetGlobalString(lParam)
    Call RemoveWatch(wParam, sPrintername)
    
ElseIf wMsg = WM_MCL_CHANGENOTIFY Then
    '\\ hwnd is the window that recieved the change notification,
    '\\ wParam is (currently) zero,
    '\\ lParam is the pdwChange which tells you what changed...
    Call ChangeNotify(hwnd, wParam, lParam)

ElseIf wMsg = WM_HOTKEY Then
    '\\ Hotkey pressed...
    Call HotkeyPressed
    
Else
   VB_WindowProc = CallWindowProc(hOldProc, hwnd, wMsg, wParam, lParam)
End If

End Function

Public Function StringFromPointer(lpString As Long, lMaxlength As Long) As String

Dim sRet As String
Dim lRet As Long

If lpString = 0 Then
    StringFromPointer = ""
    Exit Function
End If

If Not IsBadStringPtrByLong(lpString, lMaxlength) Then
    '\ Set aside space to copy string to
    sRet = String$(lMaxlength, 0)
    CopyMemory ByVal sRet, ByVal lpString, ByVal Len(sRet)
    If InStr(sRet, Chr$(0)) > 0 Then
        sRet = Left$(sRet, InStr(sRet, Chr$(0)) - 1)
    End If
End If

StringFromPointer = sRet

End Function

Public Function WM_MCL_CHANGENOTIFY() As Long
Static msg As Long

If msg = 0 Then
    msg = RegisterWindowMessage(MSG_CHANGENOTIFY)
End If

WM_MCL_CHANGENOTIFY = msg

End Function

Public Function WM_MCL_STARTWATCH() As Long

Static msg As Long

If msg = 0 Then
    msg = RegisterWindowMessage(MSG_STARTWATCH)
End If

WM_MCL_STARTWATCH = msg

End Function


Public Function WM_MCL_STOPWATCH() As Long

Static msg As Long

If msg = 0 Then
    msg = RegisterWindowMessage(MSG_STOPWATCH)
End If

WM_MCL_STOPWATCH = msg

End Function


'\\ -- [ LastSystemError ]--------------
'\\ Returns the message from the system which
'\\ describes the last dll error to occur, as
'\\ held in Err.LastDllError. This function
'\\ should be called as soon after the API call
'\\ which might have errored, as this member can
'\\ be reset to zero by subsequent API calls.
'\\ ------------------------------------
Public Function LastSystemError() As String
    Dim sError As String * 500 '\\ Preinitilise a string buffer to put any error message into
    Dim lErrNum As Long
    Dim lErrMsg As Long
    lErrNum = Err.LastDllError
    lErrMsg = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, ByVal 0&, lErrNum, 0, sError, Len(sError), 0)
    LastSystemError = Trim(sError)
End Function
